LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY bin2gray IS
    GENERIC (
	    N   : natural := 4
	 );
    PORT (
       bin  : IN  std_logic_vector (N-1 DOWNTO 0);
       gray : OUT std_logic_vector (N-1 DOWNTO 0)
    );
END ENTITY bin2gray;

ARCHITECTURE rtl OF bin2gray IS
BEGIN
  gray <= bin XOR ('0'&bin((N-1) DOWNTO 1));
END ARCHITECTURE rtl;