ARCHITECTURE rtl_johnson OF cnt IS
  SIGNAL cnt_d : std_logic_vector (N-1 DOWNTO 0);
  SIGNAL cnt_q : std_logic_vector (N-1 DOWNTO 0);
BEGIN
  reg_cnt : PROCESS (clk, res)
  BEGIN
      IF res='1' THEN
        cnt_q <= (OTHERS => '0');
      ELSIF clk'EVENT AND clk='1' THEN
        cnt_q <= cnt_d;
      END IF;
  END PROCESS reg_cnt;
  cnt_d   <= cnt_q(N-2 DOWNTO 0)&NOT(cnt_q(N-1));  
  cnt_out <= cnt_q;
END ARCHITECTURE rtl_johnson;